<script lang="ts">
    // TODO if there are not repos found, show it
    import { githubResults } from "$lib/stores/githubResults.store";
    import { endpointMetaInfo } from "$lib/stores/mainPaperInfo.store";
    import Manager from "$lib/controller/Manager";
    import { search } from "$lib/stores/searchConfigStore";
    import { blur } from "svelte/transition";
    import { searchTerm } from "../ViewController";
    import CircularProgress from "@smui/circular-progress";
    import DownloadButton from "./DownloadButton.svelte";
    import TailwindTable from "./TailwindTable.svelte";

    // Reactive variable for the amount of done Zenodo searchs
    $: amountZenodoSearchs = Manager.amountDoneZenodoRepo;
</script>

<!-- <ResultTable repositories={[...$githubResults.repositories.values()]} /> -->

{#if $githubResults.repositories.size > 0}
    <div class="flex justify-center m-8">
        <div
            class="flex flex-col justify-center"
            in:blur={{ delay: 0, duration: 600 }}
        >
            <div
                style="display:flex; flex-direction: row; justify-content: space-between; gap: 30px"
            >
                <div style="display: flex; flex-direction: column">
                    Your Search Query corresponds with {$githubResults.totalRepos}
                    Repositories on GitHub, we have loaded {$githubResults
                        .repositories.size} of them:
                    <div class="w-full bg-gray-200 mb-2">
                        <div
                            class="bg-blue-600 text-xs font-medium text-blue-100 text-center p-0.5 leading-none"
                            style:width="{($githubResults.repositories.size /
                                $githubResults.totalRepos) *
                                100}%"
                        >
                            {$githubResults.repositories
                                .size}/{$githubResults.totalRepos}
                        </div>
                    </div>
                    We have searched {$amountZenodoSearchs} Repositories on Zenodo
                    so far:
                    <!-- <LinearProgress progress={($amountZenodoSearchs / $githubResults.totalRepos)} closed={($amountZenodoSearchs / $githubResults.totalRepos) === 1} /> -->
                    <div class="w-full bg-gray-200">
                        <div
                            class="bg-green-600 text-xs font-medium text-green-100 text-center p-0.5 leading-none"
                            style:width="{($amountZenodoSearchs /
                                $githubResults.totalRepos) *
                                100}%"
                        >
                            {$amountZenodoSearchs}/{$githubResults.totalRepos}
                        </div>
                    </div>

                    We extracted {$endpointMetaInfo.abstracts} Abstracts from {$endpointMetaInfo.total}
                    DOIs
                </div>
                <div
                    style="display: flex; flex-direction: column; justify-content: center; align-items: flex-end; gap: 15px"
                >
                    <div class="d-flex justify-center">
                        <DownloadButton
                            data={Array.from(
                                $githubResults.repositories.values()
                            )}
                            fileName={"BettysResult_" +
                                $searchTerm.replace(/[\s+:]/g, "_")}
                        />
                    </div>
                </div>
            </div>
        </div>
        <div class="flex justify-center">
            <p in:blur={{ delay: 0, duration: 600 }} />
        </div>
    </div>

    <div class="m-4 overflow-auto rounded-lg shadow hidden md:block">
        <TailwindTable
            repositories={[...$githubResults.repositories.values()]}
        />
    </div>
{/if}
{#if $search.state === "loading"}
    <div class="flex justify-center">
        <CircularProgress indeterminate class="w-10 h-10" />
    </div>
{/if}
